OpenJPH: ojph::local::subband Class Reference

OpenJPH Open-source implementation of JPEG2000 Part-15

Loading...
Searching...
No Matches
ojph::local::subband Class Reference

`#include <ojph_subband.h>`

## Public Member Functions
| subband ()
void | finalize_alloc (codestream *codestream, const rect &band_rect, resolution *res, ui32 res_num, ui32 subband_num)
void | exchange_buf (line_buf *l)
line_buf * | get_line ()
void | push_line ()
void | get_cb_indices (const size &num_precincts, precinct *precincts)
float | get_delta ()
bool | exists ()
line_buf * | pull_line ()
resolution * | get_parent ()
const resolution * | get_parent () const

## Static Public Member Functions
static void | pre_alloc (codestream *codestream, const rect &band_rect, ui32 comp_num, ui32 res_num, ui32 transform_flags)

## Private Attributes
bool | empty
ui32 | res_num
ui32 | band_num
bool | reversible
rect | band_rect
line_buf * | lines
resolution * | parent
codeblock * | blocks
size | num_blocks
size | log_PP
ui32 | xcb_prime
ui32 | ycb_prime
ui32 | cur_cb_row
int | cur_line
int | cur_cb_height
float | delta
float | delta_inv
ui32 | K_max
coded_cb_header * | coded_cbs
mem_elastic_allocator * | elastic

## Friends
struct | precinct

## Detailed Description

Definition at line 62 of file ojph_subband.h.

## Constructor & Destructor Documentation

## ◆ subband()

ojph::local::subband::subband | ( |  | ) |
| inline

Definition at line 66 of file ojph_subband.h.

References band_num, blocks, coded_cbs, cur_cb_height, cur_cb_row, cur_line, delta, delta_inv, elastic, empty, K_max, lines, parent, res_num, reversible, xcb_prime, and ycb_prime.

## Member Function Documentation

## ◆ exchange_buf()

void ojph::local::subband::exchange_buf | ( | line_buf * | l | ) |

Definition at line 278 of file ojph_subband.cpp.

References empty, ojph::line_buf::flags, lines, ojph::line_buf::p, ojph::line_buf::pre_size, and ojph::line_buf::size.

## ◆ exists()

bool ojph::local::subband::exists | ( |  | ) |
| inline

Definition at line 94 of file ojph_subband.h.

References empty.

## ◆ finalize_alloc()

void ojph::local::subband::finalize_alloc | ( | codestream * | codestream,
|  | const rect & | band_rect,
|  | resolution * | res,
|  | ui32 | res_num,
|  | ui32 | subband_num )

Definition at line 117 of file ojph_subband.cpp.

References ojph::local::param_cod::access_atk(), ojph::local::codestream::access_dfs(), ojph::local::codestream::access_qcd(), band_num, band_rect, blocks, coded_cbs, cur_cb_height, cur_cb_row, cur_line, delta, delta_inv, elastic, empty, ojph::local::codestream::get_allocator(), ojph::local::codestream::get_coc(), ojph::local::param_dfs::get_dfs(), ojph::local::param_cod::get_dfs_index(), ojph::local::codestream::get_elastic_alloc(), ojph::local::param_qcd::get_irrev_delta(), ojph::local::param_qcd::get_Kmax(), ojph::local::param_cod::get_log_block_dims(), ojph::local::param_cod::get_log_precinct_size(), ojph::local::param_cod::get_num_decompositions(), ojph::local::param_qcd::get_qcc(), ojph::size::h, ojph::local::param_cod::is_dfs_defined(), ojph::local::param_atk::is_reversible(), K_max, lines, log_PP, num_blocks, ojph_max, ojph_min, parent, ojph::mem_fixed_allocator::post_alloc_data(), ojph::mem_fixed_allocator::post_alloc_obj(), ojph::local::param_qcd::propose_precision(), res_num, reversible, ojph::size::w, xcb_prime, and ycb_prime.

## ◆ get_cb_indices()

void ojph::local::subband::get_cb_indices | ( | const size & | num_precincts,
|  | precinct * | precincts )

Definition at line 223 of file ojph_subband.cpp.

References band_num, ojph::local::precinct::cb_idxs, empty, ojph::size::h, log_PP, num_blocks, ojph_max, ojph_min, ojph::rect::org, parent, precinct, ojph::rect::siz, ojph::size::w, ojph::point::x, xcb_prime, ojph::point::y, and ycb_prime.

## ◆ get_delta()

float ojph::local::subband::get_delta | ( |  | ) |
| inline

Definition at line 93 of file ojph_subband.h.

References delta.

## ◆ get_line()

line_buf * ojph::local::subband::get_line | ( |  | ) |
| inline

Definition at line 89 of file ojph_subband.h.

References lines.

## ◆ get_parent() [1/2]

resolution * ojph::local::subband::get_parent | ( |  | ) |
| inline

Definition at line 97 of file ojph_subband.h.

References parent.

## ◆ get_parent() [2/2]

const resolution * ojph::local::subband::get_parent | ( |  | ) | const
| inline

Definition at line 98 of file ojph_subband.h.

References parent.

## ◆ pre_alloc()

void ojph::local::subband::pre_alloc | ( | codestream * | codestream,
|  | const rect & | band_rect,
|  | ui32 | comp_num,
|  | ui32 | res_num,
|  | ui32 | transform_flags )
| static

Definition at line 57 of file ojph_subband.cpp.

References ojph::local::param_cod::access_atk(), ojph::local::codestream::access_qcd(), band_rect, empty, ojph::local::codestream::get_allocator(), ojph::local::codestream::get_coc(), ojph::local::param_cod::get_log_block_dims(), ojph::local::param_cod::get_log_precinct_size(), ojph::local::param_qcd::get_qcc(), ojph::size::h, ojph::local::resolution::HORZ_TRX, ojph::local::param_atk::is_reversible(), log_PP, num_blocks, ojph_min, ojph::local::codeblock::pre_alloc(), ojph::mem_fixed_allocator::pre_alloc_data(), ojph::mem_fixed_allocator::pre_alloc_obj(), ojph::local::param_qcd::propose_precision(), res_num, reversible, ojph::local::resolution::VERT_TRX, ojph::size::w, xcb_prime, and ycb_prime.

Referenced by ojph::local::resolution::pre_alloc().

## ◆ pull_line()

line_buf * ojph::local::subband::pull_line | ( |  | ) |

Definition at line 335 of file ojph_subband.cpp.

References band_rect, blocks, coded_cbs, cur_cb_height, cur_cb_row, cur_line, empty, ojph::size::h, lines, num_blocks, ojph_max, ojph_min, pull_line(), ojph::size::w, xcb_prime, and ycb_prime.

Referenced by pull_line().

## ◆ push_line()

void ojph::local::subband::push_line | ( |  | ) |

Definition at line 291 of file ojph_subband.cpp.

References band_rect, blocks, coded_cbs, cur_cb_height, cur_cb_row, cur_line, elastic, empty, ojph::size::h, lines, num_blocks, ojph_max, ojph_min, ojph::size::w, xcb_prime, and ycb_prime.

## Friends And Related Symbol Documentation

## ◆ precinct

friend struct precinct
| friend

Definition at line 64 of file ojph_subband.h.

References precinct.

Referenced by get_cb_indices(), and precinct.

## Member Data Documentation

## ◆ band_num

ui32 ojph::local::subband::band_num
| private

Definition at line 103 of file ojph_subband.h.

Referenced by finalize_alloc(), get_cb_indices(), and subband().

## ◆ band_rect

rect ojph::local::subband::band_rect
| private

Definition at line 105 of file ojph_subband.h.

Referenced by finalize_alloc(), pre_alloc(), pull_line(), and push_line().

## ◆ blocks

codeblock* ojph::local::subband::blocks
| private

Definition at line 108 of file ojph_subband.h.

Referenced by finalize_alloc(), pull_line(), push_line(), and subband().

## ◆ coded_cbs

coded_cb_header* ojph::local::subband::coded_cbs
| private

Definition at line 117 of file ojph_subband.h.

Referenced by finalize_alloc(), pull_line(), push_line(), and subband().

## ◆ cur_cb_height

int ojph::local::subband::cur_cb_height
| private

Definition at line 114 of file ojph_subband.h.

Referenced by finalize_alloc(), pull_line(), push_line(), and subband().

## ◆ cur_cb_row

ui32 ojph::local::subband::cur_cb_row
| private

Definition at line 112 of file ojph_subband.h.

Referenced by finalize_alloc(), pull_line(), push_line(), and subband().

## ◆ cur_line

int ojph::local::subband::cur_line
| private

Definition at line 113 of file ojph_subband.h.

Referenced by finalize_alloc(), pull_line(), push_line(), and subband().

## ◆ delta

float ojph::local::subband::delta
| private

Definition at line 115 of file ojph_subband.h.

Referenced by finalize_alloc(), get_delta(), and subband().

## ◆ delta_inv

float ojph::local::subband::delta_inv
| private

Definition at line 115 of file ojph_subband.h.

Referenced by finalize_alloc(), and subband().

## ◆ elastic

mem_elastic_allocator* ojph::local::subband::elastic
| private

Definition at line 118 of file ojph_subband.h.

Referenced by finalize_alloc(), push_line(), and subband().

## ◆ empty

bool ojph::local::subband::empty
| private

Definition at line 101 of file ojph_subband.h.

Referenced by exchange_buf(), exists(), finalize_alloc(), get_cb_indices(), pre_alloc(), pull_line(), push_line(), and subband().

## ◆ K_max

ui32 ojph::local::subband::K_max
| private

Definition at line 116 of file ojph_subband.h.

Referenced by finalize_alloc(), and subband().

## ◆ lines

line_buf* ojph::local::subband::lines
| private

Definition at line 106 of file ojph_subband.h.

Referenced by exchange_buf(), finalize_alloc(), get_line(), pull_line(), push_line(), and subband().

## ◆ log_PP

size ojph::local::subband::log_PP
| private

Definition at line 110 of file ojph_subband.h.

Referenced by finalize_alloc(), get_cb_indices(), and pre_alloc().

## ◆ num_blocks

size ojph::local::subband::num_blocks
| private

Definition at line 109 of file ojph_subband.h.

Referenced by finalize_alloc(), get_cb_indices(), pre_alloc(), pull_line(), and push_line().

## ◆ parent

resolution* ojph::local::subband::parent
| private

Definition at line 107 of file ojph_subband.h.

Referenced by finalize_alloc(), get_cb_indices(), get_parent(), get_parent(), and subband().

## ◆ res_num

ui32 ojph::local::subband::res_num
| private

Definition at line 103 of file ojph_subband.h.

Referenced by finalize_alloc(), pre_alloc(), and subband().

## ◆ reversible

bool ojph::local::subband::reversible
| private

Definition at line 104 of file ojph_subband.h.

Referenced by finalize_alloc(), pre_alloc(), and subband().

## ◆ xcb_prime

ui32 ojph::local::subband::xcb_prime
| private

Definition at line 111 of file ojph_subband.h.

Referenced by finalize_alloc(), get_cb_indices(), pre_alloc(), pull_line(), push_line(), and subband().

## ◆ ycb_prime

ui32 ojph::local::subband::ycb_prime
| private

Definition at line 111 of file ojph_subband.h.

Referenced by finalize_alloc(), get_cb_indices(), pre_alloc(), pull_line(), push_line(), and subband().

The documentation for this class was generated from the following files:

- /build/openjph/src/OpenJPH/src/core/codestream/ojph_subband.h
- /build/openjph/src/OpenJPH/src/core/codestream/ojph_subband.cpp